diff --git a/src/include/storage/lock.h b/src/include/storage/lock.h
index e8b50fe..493deb0 100644
--- a/src/include/storage/lock.h
+++ b/src/include/storage/lock.h
@@ -544,6 +544,9 @@ extern void LockReleaseSession(LOCKMETHODID lockmethodid);
 extern void LockReleaseCurrentOwner(LOCALLOCK **locallocks, int nlocks);
 extern void LockReassignCurrentOwner(LOCALLOCK **locallocks, int nlocks);
 extern bool LockHeldByMe(const LOCKTAG *locktag, LOCKMODE lockmode);
+#ifdef USE_ASSERT_CHECKING
+extern HTAB *GetLockMethodLocalHash(void);
+#endif
 extern bool LockHasWaiters(const LOCKTAG *locktag,
 						   LOCKMODE lockmode, bool sessionLock);
 extern VirtualTransactionId *GetLockConflicts(const LOCKTAG *locktag,
diff --git a/src/include/storage/smgr.h b/src/include/storage/smgr.h
index 1543d8d..31a5ecd 100644
--- a/src/include/storage/smgr.h
+++ b/src/include/storage/smgr.h
@@ -89,6 +89,7 @@ extern void smgrcloseall(void);
 extern void smgrclosenode(RelFileNodeBackend rnode);
 extern void smgrcreate(SMgrRelation reln, ForkNumber forknum, bool isRedo);
 extern void smgrdounlink(SMgrRelation reln, bool isRedo);
+extern void smgrdosyncall(SMgrRelation *rels, int nrels);
 extern void smgrdounlinkall(SMgrRelation *rels, int nrels, bool isRedo);
 extern void smgrextend(SMgrRelation reln, ForkNumber forknum,
 					   BlockNumber blocknum, char *buffer, bool skipFsync);
diff --git a/src/include/utils/rel.h b/src/include/utils/rel.h
index bf7a7df..379272d 100644
--- a/src/include/utils/rel.h
+++ b/src/include/utils/rel.h
@@ -65,25 +65,45 @@ typedef struct RelationData
 
 	/*----------
 	 * rd_createSubid is the ID of the highest subtransaction the rel has
-	 * survived into; or zero if the rel was not created in the current top
-	 * transaction.  This can be now be relied on, whereas previously it could
-	 * be "forgotten" in earlier releases. Likewise, rd_newRelfilenodeSubid is
-	 * the ID of the highest subtransaction the relfilenode change has
-	 * survived into, or zero if not changed in the current transaction (or we
-	 * have forgotten changing it). rd_newRelfilenodeSubid can be forgotten
-	 * when a relation has multiple new relfilenodes within a single
-	 * transaction, with one of them occurring in a subsequently aborted
-	 * subtransaction, e.g.
+	 * survived into or zero if the rel or its rd_node was created before the
+	 * current top transaction.  (IndexStmt.oldNode leads to the case of a new
+	 * rel with an old rd_node.)  rd_firstRelfilenodeSubid is the ID of the
+	 * highest subtransaction an rd_node change has survived into or zero if
+	 * rd_node matches the value it had at the start of the current top
+	 * transaction.  (Rolling back the subtransaction that
+	 * rd_firstRelfilenodeSubid denotes would restore rd_node to the value it
+	 * had at the start of the current top transaction.  Rolling back any
+	 * lower subtransaction would not.)  Their accuracy is critical to
+	 * RelationNeedsWAL().
+	 *
+	 * rd_newRelfilenodeSubid is the ID of the highest subtransaction the
+	 * most-recent relfilenode change has survived into or zero if not changed
+	 * in the current transaction (or we have forgotten changing it).  This
+	 * field is accurate when non-zero, but it can be zero when a relation has
+	 * multiple new relfilenodes within a single transaction, with one of them
+	 * occurring in a subsequently aborted subtransaction, e.g.
 	 *		BEGIN;
 	 *		TRUNCATE t;
 	 *		SAVEPOINT save;
 	 *		TRUNCATE t;
 	 *		ROLLBACK TO save;
 	 *		-- rd_newRelfilenodeSubid is now forgotten
+	 *
+	 * If every rd_*Subid field is zero, they are read-only outside
+	 * relcache.c.  Files that trigger rd_node changes by updating
+	 * pg_class.reltablespace and/or pg_class.relfilenode call
+	 * RelationAssumeNewRelfilenode() to update rd_*Subid.
+	 *
+	 * rd_droppedSubid is the ID of the highest subtransaction that a drop of
+	 * the rel has survived into.  In entries visible outside relcache.c, this
+	 * is always zero.
 	 */
 	SubTransactionId rd_createSubid;	/* rel was created in current xact */
-	SubTransactionId rd_newRelfilenodeSubid;	/* new relfilenode assigned in
-												 * current xact */
+	SubTransactionId rd_newRelfilenodeSubid;	/* highest subxact changing
+												 * rd_node to current value */
+	SubTransactionId rd_firstRelfilenodeSubid;	/* highest subxact changing
+												 * rd_node to any value */
+	SubTransactionId rd_droppedSubid;	/* dropped with another Subid set */
 
 	Form_pg_class rd_rel;		/* RELATION tuple */
 	TupleDesc	rd_att;			/* tuple descriptor */
@@ -525,9 +545,16 @@ typedef struct ViewOptions
 /*
  * RelationNeedsWAL
  *		True if relation needs WAL.
- */
-#define RelationNeedsWAL(relation) \
-	((relation)->rd_rel->relpersistence == RELPERSISTENCE_PERMANENT)
+ *
+ * Returns false if wal_level = minimal and this relation is created or
+ * truncated in the current transaction.  See "Skipping WAL for New
+ * RelFileNode" in src/backend/access/transam/README.
+ */
+#define RelationNeedsWAL(relation)										\
+	((relation)->rd_rel->relpersistence == RELPERSISTENCE_PERMANENT &&	\
+	 (XLogIsNeeded() ||													\
+	  (relation->rd_createSubid == InvalidSubTransactionId &&			\
+	   relation->rd_firstRelfilenodeSubid == InvalidSubTransactionId)))
 
 /*
  * RelationUsesLocalBuffers
diff --git a/src/include/utils/relcache.h b/src/include/utils/relcache.h
index 90487b2..66e247d 100644
--- a/src/include/utils/relcache.h
+++ b/src/include/utils/relcache.h
@@ -106,9 +106,10 @@ extern Relation RelationBuildLocalRelation(const char *relname,
 										   char relkind);
 
 /*
- * Routine to manage assignment of new relfilenode to a relation
+ * Routines to manage assignment of new relfilenode to a relation
  */
 extern void RelationSetNewRelfilenode(Relation relation, char persistence);
+extern void RelationAssumeNewRelfilenode(Relation relation);
 
 /*
  * Routines for flushing/rebuilding relcache entries in various scenarios
@@ -121,6 +122,11 @@ extern void RelationCacheInvalidate(void);
 
 extern void RelationCloseSmgrByOid(Oid relationId);
 
+#ifdef USE_ASSERT_CHECKING
+extern void AssertPendingSyncs_RelationCache(void);
+#else
+#define AssertPendingSyncs_RelationCache() do {} while (0)
+#endif
 extern void AtEOXact_RelationCache(bool isCommit);
 extern void AtEOSubXact_RelationCache(bool isCommit, SubTransactionId mySubid,
 									  SubTransactionId parentSubid);
diff --git a/src/test/recovery/t/018_wal_optimize.pl b/src/test/recovery/t/018_wal_optimize.pl
new file mode 100644
index 0000000..78d81e1
--- /dev/null
+++ b/src/test/recovery/t/018_wal_optimize.pl
@@ -0,0 +1,374 @@
+# Test WAL replay when some operation has skipped WAL.
+#
+# These tests exercise code that once violated the mandate described in
+# src/backend/access/transam/README section "Skipping WAL for New
+# RelFileNode".  The tests work by committing some transactions, initiating an
+# immediate shutdown, and confirming that the expected data survives recovery.
+# For many years, individual commands made the decision to skip WAL, hence the
+# frequent appearance of COPY in these tests.
+use strict;
+use warnings;
+
+use PostgresNode;
+use TestLib;
+use Test::More tests => 34;
+
+sub check_orphan_relfilenodes
+{
+	my ($node, $test_name) = @_;
+
+	my $db_oid = $node->safe_psql('postgres',
+		"SELECT oid FROM pg_database WHERE datname = 'postgres'");
+	my $prefix               = "base/$db_oid/";
+	my $filepaths_referenced = $node->safe_psql(
+		'postgres', "
+	   SELECT pg_relation_filepath(oid) FROM pg_class
+	   WHERE reltablespace = 0 AND relpersistence <> 't' AND
+	   pg_relation_filepath(oid) IS NOT NULL;");
+	is_deeply(
+		[
+			sort(map { "$prefix$_" }
+				  grep(/^[0-9]+$/, slurp_dir($node->data_dir . "/$prefix")))
+		],
+		[ sort split /\n/, $filepaths_referenced ],
+		$test_name);
+	return;
+}
+
+# We run this same test suite for both wal_level=minimal and replica.
+sub run_wal_optimize
+{
+	my $wal_level = shift;
+
+	my $node = get_new_node("node_$wal_level");
+	$node->init;
+	$node->append_conf(
+		'postgresql.conf', qq(
+wal_level = $wal_level
+max_prepared_transactions = 1
+wal_log_hints = on
+wal_skip_threshold = 0
+#wal_debug = on
+));
+	$node->start;
+
+	# Setup
+	my $tablespace_dir = $node->basedir . '/tablespace_other';
+	mkdir($tablespace_dir);
+	$tablespace_dir = TestLib::perl2host($tablespace_dir);
+	$node->safe_psql('postgres',
+		"CREATE TABLESPACE other LOCATION '$tablespace_dir';");
+
+	# Test direct truncation optimization.  No tuples.
+	$node->safe_psql(
+		'postgres', "
+		BEGIN;
+		CREATE TABLE trunc (id serial PRIMARY KEY);
+		TRUNCATE trunc;
+		COMMIT;");
+	$node->stop('immediate');
+	$node->start;
+	my $result = $node->safe_psql('postgres', "SELECT count(*) FROM trunc;");
+	is($result, qq(0), "wal_level = $wal_level, TRUNCATE with empty table");
+
+	# Test truncation with inserted tuples within the same transaction.
+	# Tuples inserted after the truncation should be seen.
+	$node->safe_psql(
+		'postgres', "
+		BEGIN;
+		CREATE TABLE trunc_ins (id serial PRIMARY KEY);
+		INSERT INTO trunc_ins VALUES (DEFAULT);
+		TRUNCATE trunc_ins;
+		INSERT INTO trunc_ins VALUES (DEFAULT);
+		COMMIT;");
+	$node->stop('immediate');
+	$node->start;
+	$result = $node->safe_psql('postgres', "SELECT count(*) FROM trunc_ins;");
+	is($result, qq(1), "wal_level = $wal_level, TRUNCATE INSERT");
+
+	# Same for prepared transaction.
+	# Tuples inserted after the truncation should be seen.
+	$node->safe_psql(
+		'postgres', "
+		BEGIN;
+		CREATE TABLE twophase (id serial PRIMARY KEY);
+		INSERT INTO twophase VALUES (DEFAULT);
+		TRUNCATE twophase;
+		INSERT INTO twophase VALUES (DEFAULT);
+		PREPARE TRANSACTION 't';
+		COMMIT PREPARED 't';");
+	$node->stop('immediate');
+	$node->start;
+	$result = $node->safe_psql('postgres', "SELECT count(*) FROM twophase;");
+	is($result, qq(1), "wal_level = $wal_level, TRUNCATE INSERT PREPARE");
+
+	# Same with writing WAL at end of xact, instead of syncing.
+	# Tuples inserted after the truncation should be seen.
+	$node->safe_psql(
+		'postgres', "
+		SET wal_skip_threshold = '1TB';
+		BEGIN;
+		CREATE TABLE noskip (id serial PRIMARY KEY);
+		INSERT INTO noskip VALUES (DEFAULT);
+		TRUNCATE noskip;
+		INSERT INTO noskip VALUES (DEFAULT);
+		COMMIT;");
+	$node->stop('immediate');
+	$node->start;
+	$result = $node->safe_psql('postgres', "SELECT count(*) FROM noskip;");
+	is($result, qq(1),
+		"wal_level = $wal_level, TRUNCATE with end-of-xact WAL");
+
+	# Data file for COPY query in subsequent tests
+	my $basedir   = $node->basedir;
+	my $copy_file = "$basedir/copy_data.txt";
+	TestLib::append_to_file(
+		$copy_file, qq(20000,30000
+20001,30001
+20002,30002));
+
+	# Test truncation with inserted tuples using both INSERT and COPY.  Tuples
+	# inserted after the truncation should be seen.
+	$node->safe_psql(
+		'postgres', "
+		BEGIN;
+		CREATE TABLE ins_trunc (id serial PRIMARY KEY, id2 int);
+		INSERT INTO ins_trunc VALUES (DEFAULT, generate_series(1,10000));
+		TRUNCATE ins_trunc;
+		INSERT INTO ins_trunc (id, id2) VALUES (DEFAULT, 10000);
+		COPY ins_trunc FROM '$copy_file' DELIMITER ',';
+		INSERT INTO ins_trunc (id, id2) VALUES (DEFAULT, 10000);
+		COMMIT;");
+	$node->stop('immediate');
+	$node->start;
+	$result = $node->safe_psql('postgres', "SELECT count(*) FROM ins_trunc;");
+	is($result, qq(5), "wal_level = $wal_level, TRUNCATE COPY INSERT");
+
+	# Test truncation with inserted tuples using COPY.  Tuples copied after
+	# the truncation should be seen.
+	$node->safe_psql(
+		'postgres', "
+		BEGIN;
+		CREATE TABLE trunc_copy (id serial PRIMARY KEY, id2 int);
+		INSERT INTO trunc_copy VALUES (DEFAULT, generate_series(1,3000));
+		TRUNCATE trunc_copy;
+		COPY trunc_copy FROM '$copy_file' DELIMITER ',';
+		COMMIT;");
+	$node->stop('immediate');
+	$node->start;
+	$result =
+	  $node->safe_psql('postgres', "SELECT count(*) FROM trunc_copy;");
+	is($result, qq(3), "wal_level = $wal_level, TRUNCATE COPY");
+
+	# Like previous test, but rollback SET TABLESPACE in a subtransaction.
+	$node->safe_psql(
+		'postgres', "
+		BEGIN;
+		CREATE TABLE spc_abort (id serial PRIMARY KEY, id2 int);
+		INSERT INTO spc_abort VALUES (DEFAULT, generate_series(1,3000));
+		TRUNCATE spc_abort;
+		SAVEPOINT s;
+		  ALTER TABLE spc_abort SET TABLESPACE other; ROLLBACK TO s;
+		COPY spc_abort FROM '$copy_file' DELIMITER ',';
+		COMMIT;");
+	$node->stop('immediate');
+	$node->start;
+	$result = $node->safe_psql('postgres', "SELECT count(*) FROM spc_abort;");
+	is($result, qq(3),
+		"wal_level = $wal_level, SET TABLESPACE abort subtransaction");
+
+	# in different subtransaction patterns
+	$node->safe_psql(
+		'postgres', "
+		BEGIN;
+		CREATE TABLE spc_commit (id serial PRIMARY KEY, id2 int);
+		INSERT INTO spc_commit VALUES (DEFAULT, generate_series(1,3000));
+		TRUNCATE spc_commit;
+		SAVEPOINT s; ALTER TABLE spc_commit SET TABLESPACE other; RELEASE s;
+		COPY spc_commit FROM '$copy_file' DELIMITER ',';
+		COMMIT;");
+	$node->stop('immediate');
+	$node->start;
+	$result =
+	  $node->safe_psql('postgres', "SELECT count(*) FROM spc_commit;");
+	is($result, qq(3),
+		"wal_level = $wal_level, SET TABLESPACE commit subtransaction");
+
+	$node->safe_psql(
+		'postgres', "
+		BEGIN;
+		CREATE TABLE spc_nest (id serial PRIMARY KEY, id2 int);
+		INSERT INTO spc_nest VALUES (DEFAULT, generate_series(1,3000));
+		TRUNCATE spc_nest;
+		SAVEPOINT s;
+			ALTER TABLE spc_nest SET TABLESPACE other;
+			SAVEPOINT s2;
+				ALTER TABLE spc_nest SET TABLESPACE pg_default;
+			ROLLBACK TO s2;
+			SAVEPOINT s2;
+				ALTER TABLE spc_nest SET TABLESPACE pg_default;
+			RELEASE s2;
+		ROLLBACK TO s;
+		COPY spc_nest FROM '$copy_file' DELIMITER ',';
+		COMMIT;");
+	$node->stop('immediate');
+	$node->start;
+	$result = $node->safe_psql('postgres', "SELECT count(*) FROM spc_nest;");
+	is($result, qq(3),
+		"wal_level = $wal_level, SET TABLESPACE nested subtransaction");
+
+	$node->safe_psql(
+		'postgres', "
+		CREATE TABLE spc_hint (id int);
+		INSERT INTO spc_hint VALUES (1);
+		BEGIN;
+		ALTER TABLE spc_hint SET TABLESPACE other;
+		CHECKPOINT;
+		SELECT * FROM spc_hint;  -- set hint bit
+		INSERT INTO spc_hint VALUES (2);
+		COMMIT;");
+	$node->stop('immediate');
+	$node->start;
+	$result = $node->safe_psql('postgres', "SELECT count(*) FROM spc_hint;");
+	is($result, qq(2), "wal_level = $wal_level, SET TABLESPACE, hint bit");
+
+	$node->safe_psql(
+		'postgres', "
+		BEGIN;
+		CREATE TABLE idx_hint (c int PRIMARY KEY);
+		SAVEPOINT q; INSERT INTO idx_hint VALUES (1); ROLLBACK TO q;
+		CHECKPOINT;
+		INSERT INTO idx_hint VALUES (1);  -- set index hint bit
+		INSERT INTO idx_hint VALUES (2);
+		COMMIT;");
+	$node->stop('immediate');
+	$node->start;
+	$result = $node->psql('postgres',);
+	my ($ret, $stdout, $stderr) =
+	  $node->psql('postgres', "INSERT INTO idx_hint VALUES (2);");
+	is($ret, qq(3), "wal_level = $wal_level, unique index LP_DEAD");
+	like(
+		$stderr,
+		qr/violates unique/,
+		"wal_level = $wal_level, unique index LP_DEAD message");
+
+	# UPDATE touches two buffers for one row.
+	$node->safe_psql(
+		'postgres', "
+		BEGIN;
+		CREATE TABLE upd (id serial PRIMARY KEY, id2 int);
+		INSERT INTO upd (id, id2) VALUES (DEFAULT, generate_series(1,10000));
+		COPY upd FROM '$copy_file' DELIMITER ',';
+		UPDATE upd SET id2 = id2 + 1;
+		DELETE FROM upd;
+		COMMIT;");
+	$node->stop('immediate');
+	$node->start;
+	$result = $node->safe_psql('postgres', "SELECT count(*) FROM upd;");
+	is($result, qq(0),
+		"wal_level = $wal_level, UPDATE touches two buffers for one row");
+
+	# Test consistency of COPY with INSERT for table created in the same
+	# transaction.
+	$node->safe_psql(
+		'postgres', "
+		BEGIN;
+		CREATE TABLE ins_copy (id serial PRIMARY KEY, id2 int);
+		INSERT INTO ins_copy VALUES (DEFAULT, 1);
+		COPY ins_copy FROM '$copy_file' DELIMITER ',';
+		COMMIT;");
+	$node->stop('immediate');
+	$node->start;
+	$result = $node->safe_psql('postgres', "SELECT count(*) FROM ins_copy;");
+	is($result, qq(4), "wal_level = $wal_level, INSERT COPY");
+
+	# Test consistency of COPY that inserts more to the same table using
+	# triggers.  If the INSERTS from the trigger go to the same block data
+	# is copied to, and the INSERTs are WAL-logged, WAL replay will fail when
+	# it tries to replay the WAL record but the "before" image doesn't match,
+	# because not all changes were WAL-logged.
+	$node->safe_psql(
+		'postgres', "
+		BEGIN;
+		CREATE TABLE ins_trig (id serial PRIMARY KEY, id2 text);
+		CREATE FUNCTION ins_trig_before_row_trig() RETURNS trigger
+		  LANGUAGE plpgsql as \$\$
+		  BEGIN
+			IF new.id2 NOT LIKE 'triggered%' THEN
+			  INSERT INTO ins_trig
+				VALUES (DEFAULT, 'triggered row before' || NEW.id2);
+			END IF;
+			RETURN NEW;
+		  END; \$\$;
+		CREATE FUNCTION ins_trig_after_row_trig() RETURNS trigger
+		  LANGUAGE plpgsql as \$\$
+		  BEGIN
+			IF new.id2 NOT LIKE 'triggered%' THEN
+			  INSERT INTO ins_trig
+				VALUES (DEFAULT, 'triggered row after' || OLD.id2);
+			END IF;
+			RETURN NEW;
+		  END; \$\$;
+		CREATE TRIGGER ins_trig_before_row_insert
+		  BEFORE INSERT ON ins_trig
+		  FOR EACH ROW EXECUTE PROCEDURE ins_trig_before_row_trig();
+		CREATE TRIGGER ins_trig_after_row_insert
+		  AFTER INSERT ON ins_trig
+		  FOR EACH ROW EXECUTE PROCEDURE ins_trig_after_row_trig();
+		COPY ins_trig FROM '$copy_file' DELIMITER ',';
+		COMMIT;");
+	$node->stop('immediate');
+	$node->start;
+	$result = $node->safe_psql('postgres', "SELECT count(*) FROM ins_trig;");
+	is($result, qq(9), "wal_level = $wal_level, COPY with INSERT triggers");
+
+	# Test consistency of INSERT, COPY and TRUNCATE in same transaction block
+	# with TRUNCATE triggers.
+	$node->safe_psql(
+		'postgres', "
+		BEGIN;
+		CREATE TABLE trunc_trig (id serial PRIMARY KEY, id2 text);
+		CREATE FUNCTION trunc_trig_before_stat_trig() RETURNS trigger
+		  LANGUAGE plpgsql as \$\$
+		  BEGIN
+			INSERT INTO trunc_trig VALUES (DEFAULT, 'triggered stat before');
+			RETURN NULL;
+		  END; \$\$;
+		CREATE FUNCTION trunc_trig_after_stat_trig() RETURNS trigger
+		  LANGUAGE plpgsql as \$\$
+		  BEGIN
+			INSERT INTO trunc_trig VALUES (DEFAULT, 'triggered stat before');
+			RETURN NULL;
+		  END; \$\$;
+		CREATE TRIGGER trunc_trig_before_stat_truncate
+		  BEFORE TRUNCATE ON trunc_trig
+		  FOR EACH STATEMENT EXECUTE PROCEDURE trunc_trig_before_stat_trig();
+		CREATE TRIGGER trunc_trig_after_stat_truncate
+		  AFTER TRUNCATE ON trunc_trig
+		  FOR EACH STATEMENT EXECUTE PROCEDURE trunc_trig_after_stat_trig();
+		INSERT INTO trunc_trig VALUES (DEFAULT, 1);
+		TRUNCATE trunc_trig;
+		COPY trunc_trig FROM '$copy_file' DELIMITER ',';
+		COMMIT;");
+	$node->stop('immediate');
+	$node->start;
+	$result =
+	  $node->safe_psql('postgres', "SELECT count(*) FROM trunc_trig;");
+	is($result, qq(4),
+		"wal_level = $wal_level, TRUNCATE COPY with TRUNCATE triggers");
+
+	# Test redo of temp table creation.
+	$node->safe_psql(
+		'postgres', "
+		CREATE TEMP TABLE temp (id serial PRIMARY KEY, id2 text);");
+	$node->stop('immediate');
+	$node->start;
+	check_orphan_relfilenodes($node,
+		"wal_level = $wal_level, no orphan relfilenode remains");
+
+	return;
+}
+
+# Run same test suite for multiple wal_level values.
+run_wal_optimize("minimal");
+run_wal_optimize("replica");
diff --git a/src/test/regress/sql/alter_table.sql b/src/test/regress/sql/alter_table.sql
index abe7be3..0420fa4 100644
--- a/src/test/regress/sql/alter_table.sql
+++ b/src/test/regress/sql/alter_table.sql
@@ -1358,6 +1358,13 @@ select * from another;
 
 drop table another;
 
+-- Create an index that skips WAL, then perform a SET DATA TYPE that skips
+-- rewriting the index.
+begin;
+create table skip_wal_skip_rewrite_index (c varchar(10) primary key);
+alter table skip_wal_skip_rewrite_index alter c type varchar(20);
+commit;
+
 -- table's row type
 create table tab1 (a int, b text);
 create table tab2 (x int, y tab1);
diff --git a/src/test/regress/sql/create_table.sql b/src/test/regress/sql/create_table.sql
index e835b65..62ffe53 100644
--- a/src/test/regress/sql/create_table.sql
+++ b/src/test/regress/sql/create_table.sql
@@ -318,6 +318,21 @@ CREATE TABLE default_expr_agg (a int DEFAULT (select 1));
 -- invalid use of set-returning function
 CREATE TABLE default_expr_agg (a int DEFAULT (generate_series(1,3)));
 
+-- Verify that subtransaction rollback restores rd_createSubid.
+BEGIN;
+CREATE TABLE remember_create_subid (c int);
+SAVEPOINT q; DROP TABLE remember_create_subid; ROLLBACK TO q;
+COMMIT;
+DROP TABLE remember_create_subid;
+
+-- Verify that subtransaction rollback restores rd_firstRelfilenodeSubid.
+CREATE TABLE remember_node_subid (c int);
+BEGIN;
+ALTER TABLE remember_node_subid ALTER c TYPE bigint;
+SAVEPOINT q; DROP TABLE remember_node_subid; ROLLBACK TO q;
+COMMIT;
+DROP TABLE remember_node_subid;
+
 --
 -- Partitioned tables
 --
